
#include "rtwtypes.h"

const uint16_T blcc_R_esr = 1000U;  /* 均衡电阻 */
const uint16_T blcc_T_close = 125U; /* 均衡暂停温度； */
const uint16_T blcc_T_open = 100U;  /* 均衡暂停恢复温度； */
const uint16_T blcc_V_low = 10U;    /* 均衡开启电压阈值 */

const uint16_T cmnc_Q_ratedCp = 500U;                                                                                                    /* 电池容量； */
const uint16_T cmnc_num_cellUNum = 20U;                                                                                                  /* 电压采样点实际个数； */
const uint16_T cmnc_num_modTNum = 4U;                                                                                                    /* 温度采样点实际个数； */
const uint16_T cmnc_tm_parkTime = 1800U;                                                                                                 /* 静置时间阈值； */
const uint16_T cmnm_F_polar[13] = {3880U, 5062U, 10906U, 10798U, 12885U, 12990U, 14331U, 10754U, 9378U, 10340U, 10592U, 11946U, 11515U}; /* 电池放电参数的C数组； */
const uint16_T cmnm_R_ohm[13] = {2181U, 2043U, 2040U, 1927U, 1850U, 1802U, 1771U, 1743U, 1733U, 1728U, 1748U, 1762U, 1789U};             /* 电池放电参数的Ro数组； */
const uint16_T cmnm_R_polar[13] = {1837U, 1055U, 1352U, 1453U, 1181U, 1125U, 1205U, 1283U, 1228U, 1187U, 1104U, 1170U, 1049U};           /* 电池放电参数的Rp数组； */
const uint16_T cmnm_V_ocv[13] = {3234U, 3444U, 3476U, 3553U, 3610U, 3638U, 3674U, 3758U, 3845U, 3942U, 4051U, 4106U, 4175U};             /* 电池放电参数的OCV数组； */
const uint16_T cmnm_pct_soc[13] = {0U, 50U, 100U, 200U, 300U, 400U, 500U, 600U, 700U, 800U, 900U, 950U, 1000U};                          /* 电池放电参数的SOC数组； */
const uint16_T cmnc_V_chrgFul = 4200U;                                                                                                   /* 充满电的截至电压； */

const uint16_T sfmc_I_chrgCurrOverThr = 600;     /* 充电电流阈值 */
const uint16_T sfmc_I_disChrgCurrOverThr = 600;  /* 放电电流阈值 */
const uint16_T sfmc_T_ACPlugTOverThrFlt1 = 90;   /* 慢充插头温度过高1级故障诊断阈值 */
const uint16_T sfmc_T_ACPlugTOverThrFlt2 = 100;  /* 慢充插头温度过高2级故障诊断阈值 */
const uint16_T sfmc_T_ACPlugTOverThrRec1 = 80;   /* 慢充插头温度过高1级故障恢复阈值 */
const uint16_T sfmc_T_ACPlugTOverThrRec2 = 80;   /* 慢充插头温度过高2级故障恢复阈值 */
const uint16_T sfmc_T_DCPlugTOverThrFlt1 = 90;   /* 快充插头温度过高1级故障诊断阈值 */
const uint16_T sfmc_T_DCPlugTOverThrFlt2 = 100;  /* 快充插头温度过高2级故障诊断阈值 */
const uint16_T sfmc_T_DCPlugTOverThrRec1 = 80;   /* 快充插头温度过高1级故障恢复阈值 */
const uint16_T sfmc_T_DCPlugTOverThrRec2 = 80;   /* 快充插头温度过高2级故障恢复阈值 */
const uint16_T sfmc_T_chrgModTLowThrFlt1 = 42U;  /* 充电模组温度过低1级故障诊断阈值 */
const uint16_T sfmc_T_chrgModTLowThrFlt2 = 40U;  /* 充电模组温度过低2级故障诊断阈值 */
const uint16_T sfmc_T_chrgModTLowThrRec1 = 45U;  /* 充电模组温度过低1级故障恢复阈值 */
const uint16_T sfmc_T_chrgModTLowThrRec2 = 45U;  /* 充电模组温度过低2级故障恢复阈值 */
const uint16_T sfmc_T_chrgModTOverThrFlt1 = 92U; /* 充电模组温度过高1级故障诊断阈值 */
const uint16_T sfmc_T_chrgModTOverThrFlt2 = 95U; /* 充电模组温度过高2级故障诊断阈值 */
const uint16_T sfmc_T_chrgModTOverThrRec1 = 90U; /* 充电模组温度过高1级故障恢复阈值 */
const uint16_T sfmc_T_chrgModTOverThrRec2 = 90U; /* 充电模组温度过高2级故障恢复阈值 */
const uint16_T sfmc_T_chrgMosTOverThrFlt1 = 120; /* 充电Mos温度过高1级故障诊断阈值 */
const uint16_T sfmc_T_chrgMosTOverThrFlt2 = 125; /* 充电Mos温度过高2级故障诊断阈值 */
const uint16_T sfmc_T_chrgMosTOverThrRec1 = 110; /* 充电Mos温度过高1级故障恢复阈值 */
const uint16_T sfmc_T_chrgMosTOverThrRec2 = 110; /* 充电Mos温度过高2级故障恢复阈值 */

const uint16_T sfmc_T_disChrgModTLowThrFlt1 = 25U;  /* 放电模组温度过低1级故障诊断阈值 */
const uint16_T sfmc_T_disChrgModTLowThrFlt2 = 20U;  /* 放电模组温度过低2级故障诊断阈值 */
const uint16_T sfmc_T_disChrgModTLowThrRec1 = 30U;  /* 放电模组温度过低1级故障恢复阈值 */
const uint16_T sfmc_T_disChrgModTLowThrRec2 = 30U;  /* 放电模组温度过低2级故障恢复阈值 */
const uint16_T sfmc_T_disChrgModTOverThrFlt1 = 92U; /* 放电模组温度过高1级故障诊断阈值 */
const uint16_T sfmc_T_disChrgModTOverThrFlt2 = 95U; /* 放电模组温度过高2级故障诊断阈值 */
const uint16_T sfmc_T_disChrgModTOverThrRec1 = 90U; /* 放电模组温度过高1级故障恢复阈值 */
const uint16_T sfmc_T_disChrgModTOverThrRec2 = 90U; /* 放电模组温度过高2级故障恢复阈值 */
const uint16_T sfmc_T_disChrgMosTOverThrFlt1 = 120U;
const uint16_T sfmc_T_disChrgMosTOverThrRec1 = 110U;
const uint16_T sfmc_T_disChrgMosTOverThrFlt2 = 125U;
const uint16_T sfmc_T_disChrgMosTOverThrRec2 = 110U;

const uint16_T sfmc_T_heatPanTOverThrFlt1 = 85; /* 加热板温度过高1级故障诊断阈值 */
const uint16_T sfmc_T_heatPanTOverThrFlt2 = 90; /* 加热板温度过高2级故障诊断阈值 */
const uint16_T sfmc_T_heatPanTOverThrRec1 = 80; /* 加热板温度过高1级故障恢复阈值 */
const uint16_T sfmc_T_heatPanTOverThrRec2 = 80; /* 加热板温度过高2级故障恢复阈值 */
const uint16_T sfmc_T_modTDiffThrFlt1 = 20;     /* 模组温差过大1级故障诊断阈值 */
const uint16_T sfmc_T_modTDiffThrFlt2 = 25;     /* 模组温差过大2级故障诊断阈值 */
const uint16_T sfmc_T_modTDiffThrRec1 = 15;     /* 模组温差过大1级故障恢复阈值 */
const uint16_T sfmc_T_modTDiffThrRec2 = 15;     /* 模组温差过大2级故障恢复阈值 */

const uint16_T sfmc_V_battULowThrFlt1 = 590U;    /* 总压欠压1级故障诊断阈值 */
const uint16_T sfmc_V_battULowThrFlt2 = 560U;    /* 总压欠压2级故障诊断阈值 */
const uint16_T sfmc_V_battULowThrRec1 = 600U;    /* 总压欠压1级故障恢复阈值 */
const uint16_T sfmc_V_battULowThrRec2 = 600U;    /* 总压欠压2级故障恢复阈值 */
const uint16_T sfmc_V_battUOverThrFlt1 = 850U;   /* 总压过压1级故障诊断阈值 */
const uint16_T sfmc_V_battUOverThrFlt2 = 870U;   /* 总压过压2级故障诊断阈值 */
const uint16_T sfmc_V_battUOverThrRec1 = 840U;   /* 总压过压1级故障恢复阈值 */
const uint16_T sfmc_V_battUOverThrRec2 = 840U;   /* 总压过压2级故障恢复阈值 */
const uint16_T sfmc_V_cellULowThrFlt1 = 2950U;   /* 单体电压欠压1级故障诊断阈值 */
const uint16_T sfmc_V_cellULowThrFlt2 = 2800U;   /* 单体电压欠压2级故障诊断阈值 */
const uint16_T sfmc_V_cellULowThrRec1 = 3000U;   /* 单体电压欠压1级故障恢复阈值 */
const uint16_T sfmc_V_cellULowThrRec2 = 3000U;   /* 单体电压欠压2级故障恢复阈值 */
const uint16_T sfmc_V_cellUOverThrFlt1 = 4250U;  /* 单体电压过压1级故障诊断阈值 */
const uint16_T sfmc_V_cellUOverThrFlt2 = 4350U;  /* 单体电压过压2级故障诊断阈值 */
const uint16_T sfmc_V_cellUOverThrRec1 = 4200U;  /* 单体电压过压1级故障恢复阈值 */
const uint16_T sfmc_V_cellUOverThrRec2 = 4200U;  /* 单体电压过压2级故障恢复阈值 */
const uint16_T sfmc_flg_cellUDiffThrFlt1 = 250U; /* 压差过大1级故障诊断阈值 */
const uint16_T sfmc_flg_cellUDiffThrFlt2 = 300U; /* 压差过大2级故障诊断阈值 */
const uint16_T sfmc_flg_cellUDiffThrRec1 = 250U; /* 压差过大1级故障恢复阈值 */
const uint16_T sfmc_flg_cellUDiffThrRec2 = 250U; /* 压差过大2级故障恢复阈值 */

const uint16_T sohc_Q_countThr = 60U;            /*soh计算需充入电量阈值*/
const uint16_T sohc_Q_updateDeltThr = 200U;      /*soh更新 偏差允许阈值*/

const uint16_T socc_pct_battSocLow = 0U;                     /* SOC下限值； */
const uint16_T socc_pct_battSocUp = 1000U;                   /* SOC上限值； */
const int16_T socm_I_chrgCor[3] = {50, 100, 150};            /* 充电CCV对应的电流数据； */
const int16_T socm_I_disChrgCor[3] = {-300, -100, -60};      /* 放电CCV对应的电流数据； */
const uint16_T socm_V_chrgCor[3] = {4160U, 4175U, 4188U};    /* 充电CCV对应的电压； */
const uint16_T socm_V_disChrgCor[3] = {3303U, 3359U, 3368U}; /* 放电CCV对应的电压； */
const uint16_T socc_pct_chrgCor = 980;                       /* 充电CCV对应的SOC； */   
const uint16_T socc_pct_disChrgCor = 50;                     /* 放电CCV对应的SOC； */   
const int16_T cmm_T_ChrgCurr[3] = {40,60,80};
const int16_T cmm_V_ChrgCurr[6] = {3200,3201,3900,3901,4100,4101};
const int16_T cmm_I_ChrgCurr[3][6] = {{0,100,100,100,100,50},{50,400,400,200,200,100},{40,300,300,150,150,80}};

const uint16_T tmsc_T_openThr = 45U;     /* 热管理开启温度； */
const uint16_T tmsc_T_closeMinThr = 50U; /* 热管理关闭温度（最低模组）； */
const uint16_T tmsc_T_closeMaxThr = 70U; /* 热管理开启温度（最高模组）； */
