#include "CDM.h"


static boolean_T FirstRun_CDM;

void CDM_Init(void)
{
    FirstRun_CDM = true;
}


void CDM(void)
{
    real_T cmdn_V_cellUDelt[cmnc_num_cellUNumMax];
    real_T cdmn_I_curr;
    static real_T P[4][cmnc_num_cellUNumMax];
    static real_T deltaE[cmnc_num_cellUNumMax];
    static real_T deltaR[cmnc_num_cellUNumMax];
    static real_T Lambda;
    real_T K[2];
    real_T arf[cmnc_num_cellUNumMax];
    uint16_T i;
    static uint8_T ihd_st_workStat_Delay;
    //
    if(ihd_st_workStat_Delay != 1 && ihd_st_workStat == 1)
    {
        FirstRun_CDM = true;
    }
    ihd_st_workStat_Delay = ihd_st_workStat;
    
    if (FirstRun_CDM)
    {
        for (i = 0;i < cmnc_num_cellUNum;i++)
        {
            P[0][i] = 0.001;
            P[1][i] = 0;
            P[2][i] = 0;
            P[3][i] = 0.001;
            Lambda = 1;
            deltaE[i] = 0;
            deltaR[i] = 0;
        }
    }
    
    if(ihd_st_workStat == 1)
    {
        for (i = 0;i < cmnc_num_cellUNum;i++)
        {
            cmdn_V_cellUDelt[i] = (real_T)(sfmv_V_cellU[i]  -sfmd_V_cellUAvrg) * 0.001;
        }
        cdmn_I_curr = (real_T) sfmd_I_curr * 0.1;
        //
        for (i = 0;i < cmnc_num_cellUNum;i++)
        {
            K[0] = (P[0][i]  + cdmn_I_curr * P[1][i])/(Lambda + P[0][i] + cdmn_I_curr * P[2][i] + ( P[1][i] + cdmn_I_curr * P[3][i]) * cdmn_I_curr);
            K[1] = (P[2][i]  + cdmn_I_curr * P[3][i])/(Lambda + P[0][i] + cdmn_I_curr * P[2][i] + ( P[1][i] + cdmn_I_curr * P[3][i]) * cdmn_I_curr);
            arf[i] = cmdn_V_cellUDelt[i] - (deltaE[i] + cdmn_I_curr * deltaR[i]);
            deltaE[i] = deltaE[i] + K[0] * arf[i];
            deltaR[i] = deltaR[i] + K[1] * arf[i];
            P[0][i] = ((1 -K[0])* P[0][i] -P[2][i] * K[0] * cdmn_I_curr) /Lambda;
            P[1][i] = ((1 -K[0])* P[1][i] -P[3][i] * K[0] * cdmn_I_curr) /Lambda;
            P[2][i] = (-K[1] *P[0][i] +P[2][i] * (1 - K[1] * cdmn_I_curr))/Lambda;
            P[3][i] = (-K[1] *P[1][i] +P[3][i] * (1 - K[1] * cdmn_I_curr))/Lambda;
        }
        //
        cdmd_flg_deltOCVDisable = false;
        for (i = 0;i < 1;i++)
        {
            cdmv_V_deltOCV[i] = (uint16_T) (deltaE[i]  * 1000);
            cdmv_ohm_deltR[i] = (uint16_T) (deltaR[i]  * 1000 * 10);
            if(arf[i] > 0.05 && arf[i] < -0.05)
            {
                cdmd_flg_deltOCVDisable = true;
            }
        }
    }
    else
    {
        cdmd_flg_deltOCVDisable = false;
    }
    FirstRun_CDM = false;
}